/*
 * File: ERFFIlefilter.java
 * Created on 13 sept. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNDialogEditorInterface;

import java.io.File;
import java.util.Vector;

import javax.swing.filechooser.FileFilter;

import NWNFiles.ERFFile;


/**
 * 13 sept. 2003
 * @author Alexandre Brunel
 *
 * TODO NWNDialogEditorInterface.ERFFIlefilter documentation
 */
public class ERFFIlefilter extends FileFilter
{

    private static Vector Erfextensions = null;
	
    /**
     * TODO NWNDialogEditorInterface.ERFFIlefilter Constructor documentation.
     * Constructs a ERFFIlefilter object.
     * 
     */
    public ERFFIlefilter()
    {
        super();
        Init();
        
    }

    /**
     * 
     */
    private synchronized static void Init()
    {
        if(Erfextensions == null)
        {
			Erfextensions = new Vector();

					for (int i = 0; i < ERFFile.KownERFFileTypes.length; i++)
					{
						Erfextensions.add(ERFFile.KownERFFileTypes[i].trim().toLowerCase());
					}
        }
        
    }

    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#accept(java.io.File)
     */
    public boolean accept(File f)
    {
        int index = f.getName().lastIndexOf(".");
        if (index >= 0)
        {

            String ext = f.getName().substring(index + 1).toLowerCase();

            return f.isDirectory()||Erfextensions.contains(ext);
        }
        else
        {
            return f.isDirectory();
        }
    }

    /* (non-Javadoc)
     * @see javax.swing.filechooser.FileFilter#getDescription()
     */
    public String getDescription()
    {
        // TODO Auto-generated method getDescription
        return "ERF file";
    }

}