/*
 * File: ERFFileChooser.java
 * Created on 13 sept. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNDialogEditorInterface;

import java.io.File;
import java.util.ResourceBundle;

import javax.swing.JFileChooser;

import NWNFiles.ERFFile;
import NWNLanguages.KeysHolder;
import NWNLanguages.Languages;

/**
 * 13 sept. 2003
 * @author Alexandre Brunel
 *
 * TODO NWNDialogEditorInterface.ERFFileChooser documentation
 */
public class ERFFileChooser extends JFileChooser
{

    private SidePanel sidepanel;

    private Languages resourceBundle;

    /**
     * TODO NWNDialogEditorInterface.ERFFileChooser Constructor documentation.
     * Constructs a ERFFileChooser object.
     * 
     */
    public ERFFileChooser()
    {
        super();
        init();
    }

    /**
     * TODO NWNDialogEditorInterface.ERFFileChooser Constructor documentation.
     * Constructs a ERFFileChooser object.
     * @param currentDirectory
     */
    public ERFFileChooser(File currentDirectory)
    {
        super(currentDirectory);
        init();
    }

    /**
     * Initilize the file chooser. 
     */
    private void init()
    {
        resourceBundle = (Languages) ResourceBundle.getBundle(KeysHolder.LanguagesBaseName);
        setMultiSelectionEnabled(false);

        sidepanel = new SidePanel();
        addPropertyChangeListener(sidepanel);
        setAccessory(sidepanel);
        setAcceptAllFileFilterUsed(false);
		addChoosableFileFilter(new ERFFIlefilter());
    }

    
    
    /**
     * TODO ERFFile ERFFileChooser.getSelectedERFFile
     * @return
     */
    public ERFFile getSelectedERFFile()
    {
        return sidepanel.getSelectedFile();
    }

}
