
/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */
package NWNFiles;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.nio.MappedByteBuffer;
import java.nio.channels.FileChannel;
import java.util.HashMap;
import java.util.Iterator;

import NWNFiles.NWNFilesExceptions.NameTooLong;

/**
 * <p>
 * 
 * </p>
 */
public class ERFResourceEntry {

  ///////////////////////////////////////
  // attributes


  //private boolean modified;
  
/**
 * <p>
 * Represents ...
 * </p>
 */
    private boolean inOriginalFile; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private ERFFile erfFile; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private File file; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private int size; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private int offset; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private String fileName; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private int fileType; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    protected static int MaxFileNameLength = 16; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private static HashMap FileExtensions; 

/**
 * <p>
 * Represents ...
 * </p>
 */
    private static HashMap FileIDs; 


  ///////////////////////////////////////
  // operations


  
  /*public boolean isModified()
  {
	  return modified;
  }*/
  
  
/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * @return a int with ...
 * </p><p>
 * @param extension ...
 * </p>
 */
    public static int GetID(String extension) {        
        
        
        if(FileIDs == null)
        {
            InitMaps();
        }
	Integer i = (Integer)FileIDs.get(extension);
	if(i == null)
		return -1;
	else
	        return i.intValue();
    } // end GetID        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * @return a String with ...
 * </p><p>
 * @param id ...
 * </p>
 */
    public static String GetExtension(Integer id) {        
        
        
        if(FileExtensions == null)
        {
            InitMaps();
        }
	String s = (String)FileExtensions.get(id);
	
	if(s == null)
		return ""; //$NON-NLS-1$
	else        
		return s;
    } // end GetExtension        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a ERFResourceEntry with ...
 * </p><p>
 * @param newFile ...
 * </p>
 */
    protected  ERFResourceEntry(File newFile,ERFFile caller) {        
        
	inOriginalFile = false;
	erfFile = caller;
	size = (int)newFile.length();
	fileName = newFile.getName();
	fileType = ERFResourceEntry.GetID(fileName.substring(fileName.length()-2,fileName.length()));
	fileName = fileName.substring(0,fileName.length()-3);
        file = newFile;
	fileType = ERFResourceEntry.GetID(fileName.substring(fileName.length()-2,fileName.length()));
	offset = 0;
    } // end ERFResourceEntry        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a ERFResourceEntry with ...
 * </p>
 */
    protected  ERFResourceEntry(int _size,ERFFile caller,int _offset,String _fileName,int _fileType) {        
        inOriginalFile = true;
	erfFile = caller;
	size = _size;
	fileName = _fileName;
	fileType = _fileType;
	file = null;
	offset = _offset;
    } // end ERFResourceEntry        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a File with ...
 * </p>
 */
    public File extract() throws java.io.IOException{        
        
        File retVal = new File("."); //$NON-NLS-1$
	
        return extract(retVal);
    } // end extract        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a File with ...
 * </p><p>
 * @param directory ...
 * </p>
 */
    public File extract(File directory) throws java.io.IOException{
	    
        File retVal = new File(directory,fileName+"."+GetExtension(new Integer(fileType))); //$NON-NLS-1$
	
	if(inOriginalFile)
	{
		FileInputStream sourceFile = new FileInputStream(erfFile.getFile());
		FileOutputStream destFile  = new FileOutputStream(retVal);
		
		FileChannel sourceChanel = sourceFile.getChannel();
		MappedByteBuffer source = sourceChanel.map(FileChannel.MapMode.READ_ONLY,offset,size);
		source.load();
		
		FileChannel destChannel = destFile.getChannel();
		
		destChannel.write(source);
		
		sourceFile.close();
		destFile.close();
	}
	else if(!retVal.equals(file))
	{
		FileInputStream sourceFile = new FileInputStream(file);
		FileOutputStream destFile  = new FileOutputStream(retVal);
		
		FileChannel sourceChanel = sourceFile.getChannel();
		MappedByteBuffer source = sourceChanel.map(FileChannel.MapMode.READ_ONLY,0,size);
		source.load();
		
		FileChannel destChannel = destFile.getChannel();
		
		destChannel.write(source);
		
		sourceFile.close();
		destFile.close();
	}
	
        return retVal;
    } // end extract        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a boolean with ...
 * </p>
 */
    private static void InitMaps() {        
        
        
        if(FileExtensions == null)
        {
            FileExtensions = new HashMap();
            
            FileExtensions.put(new Integer(1),"bmp"); //$NON-NLS-1$
            FileExtensions.put(new Integer(3),"tga"); //$NON-NLS-1$
            FileExtensions.put(new Integer(4),"wav"); //$NON-NLS-1$
            FileExtensions.put(new Integer(6),"plt"); //$NON-NLS-1$
            FileExtensions.put(new Integer(7),"ini"); //$NON-NLS-1$
            FileExtensions.put(new Integer(10),"txt"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2002),"mdl"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2009),"nss"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2010),"ncs"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2012),"are"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2013),"set"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2014),"ifo"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2015),"bic"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2016),"wok"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2017),"2da"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2022),"txi"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2023),"git"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2025),"uti"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2027),"utc"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2029),"dlg"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2030),"itp"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2032),"utt"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2033),"dds"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2035),"uts"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2036),"ltr"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2037),"gff"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2038),"fac"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2040),"ute"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2042),"utd"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2044),"utp"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2045),"dft"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2046),"gic"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2047),"gui"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2051),"utm"); //$NON-NLS-1$
            FileExtensions.put(new Integer(2052),"dwk");//$NON-NLS-1$
            FileExtensions.put(new Integer(2053),"pwk");//$NON-NLS-1$
            FileExtensions.put(new Integer(2056),"jrl");//$NON-NLS-1$
            FileExtensions.put(new Integer(2058),"utw");//$NON-NLS-1$
            FileExtensions.put(new Integer(2060),"ssf");//$NON-NLS-1$
            FileExtensions.put(new Integer(2065),"ptm");//$NON-NLS-1$
            FileExtensions.put(new Integer(2066),"ptt");//$NON-NLS-1$
            
        }
        if(FileIDs == null)
        {
            FileIDs = new HashMap();
            
             Iterator key = FileExtensions.keySet().iterator();
             
             while(key.hasNext())
             {
                 Object oldKey = key.next();
                 Object newKey = FileExtensions.get(oldKey);
                 
                 FileIDs.put(newKey,oldKey);
             }
        }
    } // end InitMaps        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * @return a boolean with ...
 * </p>
 */
    public boolean isInOriginalFile() {        
        
        
        
        return inOriginalFile;
    } // end isInOriginalFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a ERFFile with ...
 * </p>
 */
    public ERFFile getErfFile() {        
        
        
        
        return erfFile;
    } // end getErfFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a File with ...
 * </p>
 */
    public File getFile() {        
        
        
        
        return file;
    } // end getFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a int with ...
 * </p>
 */
    public int getSize() {        
        
        
        
        return size;
    } // end getSize        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a int with ...
 * </p>
 */
    public int getOffset() {        
        
        
        
        return offset;
    } // end getOffset        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * 
 * 
 * @return a String with ...
 * </p>
 */
    public String getFileName() {        
        
        
        
        return fileName;
    } // end getFileName        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * 
 * @return a int with ...
 * </p>
 */
    public int getFileType() {        
        
        return fileType;
    } // end getFileType        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * @param _fileType ...
 * </p>
 */
    protected void setFileType(int _fileType) {        
        erfFile.setModified(true);
        fileType = _fileType;
    } // end setFileType        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _inOriginalFile ...
 * </p>
 */
    protected void setInOriginalFile(boolean _inOriginalFile) {        
        
        erfFile.setModified(true);
        
        inOriginalFile = _inOriginalFile;
    } // end setInOriginalFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _file ...
 * </p>
 */
    protected void setFile(File _file) {        
        
        
	size = (int)_file.length();
	fileName = _file.getName();
	fileType = ERFResourceEntry.GetID(fileName.substring(fileName.length()-2,fileName.length()));
	fileName = fileName.substring(0,fileName.length()-3);
	if(fileName.length() > 16)
	{
		fileName = fileName.substring(0,16);
	}
	file = _file;
	
	offset = 0;
	
	
	erfFile.setModified(true);
		
	
    } // end setFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _erfFile ...
 * </p>
 */
    protected void setErfFile(ERFFile _erfFile) {        
        
        erfFile.setModified(true);
        
        erfFile = _erfFile;
    } // end setErfFile        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _fileName ...
 * </p>
 */
    protected void setFileName(String _fileName) throws NameTooLong{        
        
	if(_fileName.length() > 16)
	{
		throw new NameTooLong(_fileName);
	}
	erfFile.setModified(true);
        
        
        fileName = _fileName;
    } // end setFileName        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _offset ...
 * </p>
 */
    protected void setOffset(int _offset) {        
        erfFile.setModified(true);
        
        
        offset = _offset;
    } // end setOffset        

/**
 * <p>
 * Does ...
 * </p><p>
 * 
 * </p><p>
 * 
 * 
 * 
 * 
 * @param _size ...
 * </p>
 */
    protected void setSize(int _size) {        
        erfFile.setModified(true);
        
        
        size = _size;
    } // end setSize        

} // end ERFResourceEntry



