/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;
/**BYTE data type.*/
public class FieldTypeBYTE extends FieldType
{
	FieldTypeBYTE()
	{
		super(FieldType.BYTE_TYPE);
	}
	/**
	  * Returns an Integer containing the value stored in the byte.
	  * @param buffer A buffer containing the data. The current position of the buffer should be the biginning of the data and the its length should be at least one byte.
	  * @return An Integer object.
	  */
	public Object interpretData(ByteBuffer buffer)
	{
		byte read = buffer.get();
		
		return new Integer(((int)read)&0xFF);
	}
	/**
	  * Returns a one byte length array.
	  * @param data The argument should be an Integer containing the value to be stored in the byte.
	  */
	public byte[] getData(Object data)
	{
		int value = ((Integer)data).intValue();
		
		byte[] retval = new byte[1];
		
		retval[0] = (byte)value;
		
		return retval;
	}
    
}
