/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;
import java.nio.charset.Charset;
/** CHAR data type. */
public class FieldTypeCHAR extends FieldType
{
	

    FieldTypeCHAR()
	{
		super(FieldType.CHAR_TYPE);
	}
	
	/**
	  * Returns a string containing the caracter from the buffer.
	  * @param buffer A buffer containing the data. The current position of the buffer should be the biginning of the data.
	  * @return A String object
	  */
	public Object interpretData(ByteBuffer buffer)
	{
		byte[] read = new byte[1];
		String temp;
		try
		{
			buffer.get(read);
			temp = new String(read,0,1,Charset.forName(CurrentLanguage.getString(NWNFiles.language.KeysHolder.BinaryCarset)).name());
		}
		catch(java.io.UnsupportedEncodingException e)
		{
			temp = null;
		}
		return temp;
	}
	
	/**
	  * Returns an array containing a character.
	  * @param data Should be a String object.
	  */
	public byte[] getData(Object data)
	{
		try
		{
			return ((String)data).substring(0,1).getBytes(Charset.forName(CurrentLanguage.getString(NWNFiles.language.KeysHolder.BinaryCarset)).name());
		}
		catch(java.io.UnsupportedEncodingException e)
		{
			return new byte[0];
		}
		
	}
}
