/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;
/**Float data type*/
public class FieldTypeFLOAT extends FieldType
{
	FieldTypeFLOAT()
	{
		super(FieldType.FLOAT_TYPE);
	}
	/**
	  * Returns a Float containing the data.
	  * @param buffer A buffer containing the data. The current position of the buffer should be the biginning of the data.
	  * @return A Float object.
	  */
	public Object interpretData(ByteBuffer buffer)
	{
		return new Float(buffer.getFloat());
	}
	/**
	  * Returns an array containig the float value.
	  * @param data Should be a Float object.
	  */
	public byte[] getData(Object data)
	{
		byte[] retval = new byte[4];
		
		ByteBuffer temp = ByteBuffer.wrap(retval);
		temp.putFloat(((Float)data).floatValue());
		
		return retval;
	}
}
