/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;

public class FieldTypeINT64 extends FieldType
{
	FieldTypeINT64()
	{
		super(FieldType.INT64_TYPE,true);
	}
	
	public Object interpretData(ByteBuffer buffer)
	{
		byte[] read = new byte[8];
		buffer.get(read);
		
		long value;
		
		value = ((long)read[0])&0xFF;
		value |= (((long)read[1])&0xFF) << 8;
		value |= (((long)read[2])&0xFF) << 16;
		value |= (((long)read[3])&0xFF) << 24;
		value |= (((long)read[4])&0xFF) << 32;
		value |= (((long)read[5])&0xFF) << 40;
		value |= (((long)read[6])&0xFF) << 48;
		value |= (((long)read[7])&0xFF) << 56;
		
		
		return new Long(value);
	}
	
	public byte[] getData(Object data)
	{
		long value = ((Long)data).longValue();
		
		byte[] retval = new byte[8];
		
		retval[0] = (byte)value;
		retval[1] = (byte)(value >> 8);
		retval[2] = (byte)(value >> 16);
		retval[3] = (byte)(value >> 24);
		retval[4] = (byte)(value >> 32);
		retval[5] = (byte)(value >> 40);
		retval[6] = (byte)(value >> 48);
		retval[7] = (byte)(value >> 56);
		
		return retval;
	}
}
