/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;
import java.util.Vector;

//import NWNFiles.GFFFieldTypes.Structure;

public class FieldTypeList extends FieldType
{
	
	FieldTypeList()
	{
		super(FieldType.List_TYPE,true);
	}
	
	public Object interpretData(ByteBuffer buffer)
	{
		byte[] read = new byte[4];
		buffer.get(read);
		
		long size;
		
	
		size  = ((long)read[0])&0xFF;
		size |= (((long)read[1])&0xFF) << 8;
		size |= (((long)read[2])&0xFF) << 16;
		size |= (((long)read[3])&0xFF) << 24;
		
		Vector retval = new Vector((int)size);
		
		for(long i = 0;i < size;++i)
		{
			buffer.get(read);
			
			long temp;
			
			temp  = ((long)read[0])&0xFF;
			temp |= (((long)read[1])&0xFF) << 8;
			temp |= (((long)read[2])&0xFF) << 16;
			temp |= (((long)read[3])&0xFF) << 24;
			
			retval.add(new Long(temp));
		}
		
		return retval;
	}
	
	public byte[] getData(Object data)
	{
		Vector list = (Vector)data;
		
		byte[] retval = new byte[(list.size()+1)*4];
		
		ByteBuffer listBlock = ByteBuffer.wrap(retval);
		
		long temp = list.size();
		
		listBlock.put((byte)temp);
		listBlock.put((byte)(temp >> 8));
		listBlock.put((byte)(temp >> 16));
		listBlock.put((byte)(temp >> 24));
		
		for(int i = 0;i < temp;++i)
		{
			long index = ((Long)list.get(i)).longValue();
			
			listBlock.put((byte)index);
			listBlock.put((byte)(index >> 8));
			listBlock.put((byte)(index >> 16));
			listBlock.put((byte)(index >> 24));
		}
		
		return retval;
	}
	
	
    /* (non-Javadoc)
     * @see NWNFiles.GFFFieldTypes.FieldType#cloneData(java.lang.Object)
     */
    public Object cloneData(Object data)
    {
        Vector list = (Vector)data;
        
        Vector retval = new Vector();
        
        
        return retval;
    }

}
