/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;

public class FieldTypeVOID extends FieldType
{
	
	
	FieldTypeVOID()
	{
		super(FieldType.VOID_TYPE,true);
	}
	
	public Object interpretData(ByteBuffer buffer)
	{
		byte[] read = new byte[4];
		buffer.get(read);
		
		long size;
		
	
		size  = ((long)read[0])&0xFF;
		size |= (((long)read[1])&0xFF) << 8;
		size |= (((long)read[2])&0xFF) << 16;
		size |= (((long)read[3])&0xFF) << 24;
		
		byte[] data = new byte[(int)size];
		buffer.get(data);
		return ByteBuffer.wrap(data);
	}
	
	public byte[] getData(Object data)
	{
		byte[] retval;
		if(((ByteBuffer)data).hasArray())
		{
			byte[] temp = ((ByteBuffer)data).array();
			
			retval = new byte[temp.length+4];
			
			ByteBuffer dest = ByteBuffer.wrap(retval);
			
			dest.put((byte)temp.length);
			dest.put((byte)(temp.length >> 8));
			dest.put((byte)(temp.length >> 16));
			dest.put((byte)(temp.length >> 24));
			
			dest.put(temp);
		}
		else
		{
			retval = new byte[((ByteBuffer)data).remaining()+4];
			
			int size = retval.length-4;
			
			((ByteBuffer)data).get(retval,4,size);
			
			retval[0] = (byte)size;
			retval[1] = (byte)(size >> 8);
			retval[2] = (byte)(size >> 16);
			retval[3] = (byte)(size >> 24);
		}
		
		return retval;
	}
}
