/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.GFFFieldTypes;
import java.nio.ByteBuffer;

public class FieldTypeWORD extends FieldType
{
	FieldTypeWORD()
	{
		super(FieldType.WORD_TYPE);
	}
	
	public Object interpretData(ByteBuffer buffer)
	{
		byte[] read = new byte[2];
		buffer.get(read);
		
		int value = ((int)read[0])&0xFF;
		value |= (((int)read[1])&0xFF) << 8;
		
		return new Integer(value);
	}
	
	public byte[] getData(Object data)
	{
		int value = ((Integer)data).intValue();
		
		byte[] retval = new byte[2];
		
		retval[1] = (byte)value;
		retval[0] = (byte)(value >> 8);
		
		return retval;
	}
}
