/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.NWNFilesExceptions;

import java.io.File;

import NWNFiles.language.KeysHolder;

/**
 * 14 juil. 2003
 * @author Alexandre Brunel
 *
 * Thrown when e file has not been found.
 */
public class FileDoesNotExist extends NWNFileException
{

    /**
     * Constructs a FileDoesNotExist object.
     * @param file Path of the not found file
     */
    public FileDoesNotExist(File file)
    {
        super(CurrentLanguage.getString(KeysHolder.FileDoesNotExist) + file.getAbsolutePath());
    }

}
