/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.NWNFilesExceptions;

import NWNFiles.language.KeysHolder;

/**
 * 18 juil. 2003
 * @author Alexandre Brunel
 *
 * Thrown when a language id is not valid.
 */
public class InvalidLanguageId extends NWNFileException {

	/**
     * Constructs a InvalidLanguageId object.
     * @param id The invalid id. 
     */
    public  InvalidLanguageId(int id) {        
        super(CurrentLanguage.getString(KeysHolder.InvalidLanguageId) + Integer.toString(id));
    } 

} 



