/*
 * Created on 7 juil. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.NWNFilesExceptions;

import java.util.Locale;
import java.util.ResourceBundle;

import NWNFiles.language.KeysHolder;



/**
 * @author Alexandre Brunel
 *
 * Super class of all exception thrown by NWNFiles objects. 
 */
public abstract class NWNFileException extends Exception {

	protected static ResourceBundle CurrentLanguage = ResourceBundle.getBundle(KeysHolder.LanguagesBaseName); 
	
	/**
     * Constructs a NWNFileException object.
     * 
     */
    public NWNFileException() {
		super();
		
	}

	/**
	 * Constructs an exception using a user defined message.
	 * @param message Message to use.
	 */
	public NWNFileException(String message) {
		super(message);
		
	}

	public NWNFileException(String message, Throwable cause) {
		super(message, cause);
		
	}

	public NWNFileException(Throwable cause) {
		super(cause);
		
	}

    /**
     * @return
     */
    public static ResourceBundle getCurrentLanguage()
    {
        return CurrentLanguage;
    }

    /**
     * @param local
     */
    public static void setCurrentLanguage(Locale local)
    {
        CurrentLanguage = ResourceBundle.getBundle(KeysHolder.LanguagesBaseName,local);
    }

}
