
/*
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles;

import java.util.Observable;

import NWNFiles.NWNFilesExceptions.InvalidLanguageId;
/**
 * <p>
 * 
 * </p>
 */
public class StringListElement extends Observable
{

    /**
     * <p>
     * Represents ...
     * </p>
     */
    public static final int[] AvailableLanguageID =
        { 0, 1, 2, 3, 4, 5, 128, 129, 130, 131 };

    private int gender;

    ///////////////////////////////////////
    // attributes

    /**
     * <p>
     * Represents ...
     * </p>
     */
    private int languageID;

    /**
     * <p>
     * Represents ...
     * </p>
     */
    private boolean modified;
    /**
     * <p>
     * Represents ...
     * </p>
     */
    private String string;

    ///////////////////////////////////////
    // operations

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * 
     * 
     * 
     * @return a StringListElement with ...
     * </p><p>
     * @param string ...
     * </p><p>
     * @param languageID ...
     * </p>
     */
    public StringListElement(String _string, int _languageID)
        throws InvalidLanguageId
    {
        string = _string;
        setIsModified(false);
        gender = _languageID % 2;

        if (gender == 1)
        {
            languageID = _languageID - 1;
        }
        else
        {
            languageID = _languageID;
        }
        languageID /= 2;

        int i = 0;

        while (i < AvailableLanguageID.length
            && languageID != AvailableLanguageID[i])
        {
            ++i;
        }

        if (i == AvailableLanguageID.length)
        {
            throw new InvalidLanguageId(languageID);
        }

    } // end StringListElement        

    public int getGender()
    {
        return gender;
    }

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * 
     * 
     * 
     * @return a int with ...
     * </p>
     */
    public int getLanguageID()
    {

        return languageID;
    } // end getLanguageID        

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * 
     * 
     * 
     * @return a int with ...
     * </p>
     */
    public String getString()
    {
        return string;
    } // end getString        

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * 
     * 
     * 
     * @return a boolean with ...
     * </p>
     */
    public boolean isModified()
    {

        return modified;
    } // end isModified        

    public void setGender(int _gender)
    {
        setIsModified(true);
        gender = _gender;
    }

    protected void setIsModified(boolean value)
    {
        modified = value;

        if (value)
        {
            setChanged();

        }
        else
        {
            clearChanged();
        }
        notifyObservers();
    }

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * </p><p>
     * 
     * 
     * 
     * 
     * @param _languageID ...
     * </p>
     */
    public void setLanguageID(int _languageID)
    {
        setIsModified(true);

        languageID = _languageID;
    } // end setLanguageID        

    /**
     * <p>
     * Does ...
     * </p><p>
     * 
     * </p><p>
     * 
     * 
     * 
     * 
     * @param _string ...
     * </p>
     */
    public void setString(String _string)
    {
        setIsModified(true);
        string = _string;
    } // end setString        
} // end StringListElement
