/*
 * File: NWNFilesLanguageResources.java
 * Created on 14 sept. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.language;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.ResourceBundle;

/**
 * 14 sept. 2003
 * @author Alexandre Brunel
 *
 * TODO NWNFiles.language.NWNFilesLanguageResources documentation
 */
public class NWNFilesLanguageResources extends ResourceBundle
{

    private static boolean Initialized = false;
    private static Hashtable Resources = null;

    /**
     * TODO NWNFiles.language.NWNFilesLanguageResources Constructor documentation.
     * Constructs a NWNFilesLanguageResources object.
     * 
     */
    public NWNFilesLanguageResources()
    {
        super();
        createMap();
    }

    /**
     * 
     */
    private synchronized void createMap()
    {
        if (!Initialized)
        {
            Resources = new Hashtable();

            Resources.put(KeysHolder.BinaryCarset, "ISO_8859-1:1987"); //$NON-NLS-1$
            Resources.put(KeysHolder.BinaryCarset, "ISO_8859-1:1987"); //$NON-NLS-1$
            Resources.put(KeysHolder.SaveOperation, "Saving..."); //$NON-NLS-1$
            Resources.put(KeysHolder.SaveOperationEnd, "Saving done."); //$NON-NLS-1$
            Resources.put(KeysHolder.CannotDeleteFile, "Error: cannot delete the file: "); //$NON-NLS-1$
            Resources.put(KeysHolder.BadFileType, "Bad file type: "); //$NON-NLS-1$
            Resources.put(KeysHolder.FileDoesNotExist, "The file does not exist: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidFile, "Invalid file: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidLanguageId, "Invalid language id: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidFieldType, "Invalid field type: "); //$NON-NLS-1$
            Resources.put(KeysHolder.NameTooLong, "Name too long: "); //$NON-NLS-1$
            Resources.put(KeysHolder.LoadOperation, "Loading..."); //$NON-NLS-1$
            Resources.put(KeysHolder.LoadOperationDone, "Loading done."); //$NON-NLS-1$
            Initialized = true;
        }

    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#getKeys()
     */
    public Enumeration getKeys()
    {

        return Resources.keys();
    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#handleGetObject(java.lang.String)
     */
    protected Object handleGetObject(String key)
    {

        return Resources.get(key);
    }

}
