/*
 * File: NWNFilesLanguageResources_fr.java
 * Created on 14 sept. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNFiles.language;

import java.util.Enumeration;
import java.util.Hashtable;

/**
 * 14 sept. 2003
 * @author Alexandre Brunel
 *
 * TODO NWNFiles.language.NWNFilesLanguageResources_fr documentation
 */
public class NWNFilesLanguageResources_fr extends NWNFilesLanguageResources
{

    private static boolean Initialized = false;
    private static Hashtable Resources = null;
    /**
     * TODO NWNFiles.language.NWNFilesLanguageResources_fr Constructor documentation.
     * Constructs a NWNFilesLanguageResources_fr object.
     * 
     */
    public NWNFilesLanguageResources_fr()
    {
        super();
		createMap();
    }

    /**
    	 * 
    	 */
    private synchronized void createMap()
    {
        if (!Initialized)
        {
            Resources = new Hashtable();

            Resources.put(KeysHolder.SaveOperation, "Sauvegarde en cours..."); //$NON-NLS-1$
            Resources.put(KeysHolder.SaveOperationEnd, "Sauvegarde termine."); //$NON-NLS-1$
            Resources.put(KeysHolder.CannotDeleteFile, "Erreur: impossible d'effacer le fichier: "); //$NON-NLS-1$
            Resources.put(KeysHolder.BadFileType, "Type de fichier invalide: "); //$NON-NLS-1$
            Resources.put(KeysHolder.FileDoesNotExist, "Le fichier n'existe pas: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidFile, "Fichier invalide: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidLanguageId, "Identifiant de langage invalide: "); //$NON-NLS-1$
            Resources.put(KeysHolder.InvalidFieldType, "Type de champ invalide: "); //$NON-NLS-1$
            Resources.put(KeysHolder.NameTooLong, "Nom trop long: "); //$NON-NLS-1$
            Resources.put(KeysHolder.LoadOperation, "Chargement..."); //$NON-NLS-1$
            Resources.put(KeysHolder.LoadOperationDone, "Vhargement termin."); //$NON-NLS-1$
            Initialized = true;
        }

    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#getKeys()
     */
    public Enumeration getKeys()
    {

        return Resources.keys();
    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#handleGetObject(java.lang.String)
     */
    protected Object handleGetObject(String key)
    {

        return Resources.get(key);
    }
}
