/*
 * File: KeysHolder.java
 * Created on 18 juil. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNLanguages;

/**
 * 18 juil. 2003
 * @author Alexandre Brunel
 *
 * TODO NWNLanguages.KeysHolder documentation
 */
public final class KeysHolder
{
    public static final String EndButton = "EndButton";
    public static final String EndButtonMnemonic = "EndButtonMnemonic";
    public static final String NextButtonMnemonic = "NextButtonMnemonic";
    public static final String NextButton = "NextButton";
    public static final String PreviousButtonMnemonic = "PreviousButtonMnemonic";
    public static final String PreviousButton = "PreviousButton";
    public static final String ERFFileInportDialogFileSelectionTitle =
        "ERFFileInportDialogFileSelectionTitle";
    public static final String ERFFileInportDialogFileListLabel =
        "ERFFileInportDialogFileListLabel";
    public static final String ERFFileInportDialogERFFileNameLabel =
        "ERFFileInportDialogERFFileNameLabel";
    public static final String CancelButtonMnemonic = "CancelButtonMnemonic";
    public static final String OkButtonMnemonic = "OkButtonMnemonic";
    /**Ok button label*/
    public final static String CancelButton = "CancelButton";
    /**Cancel button label*/
    public final static String OkButton = "OkButton";
    /**Abort script resref label key*/
    public final static String AbortScriptLabel = "AbortScriptLabel"; //$NON-NLS-1$
    /**Email address about box field key*/
    public final static String AboutEmailAddressFormat = "AboutEmailAddressFormat"; //$NON-NLS-1$
    /**Activation script label key*/
    public final static String ActivationscriptLabel = "ActivationscriptLabel"; //$NON-NLS-1$
    /**All suported formats file filter name key*/
    public final static String AllFormatsFileFilterName = "AllFormatsFileFilterName"; //$NON-NLS-1$
    /**Animation combobox label key*/
    public final static String AnimationLabel = "AnimationLabel"; //$NON-NLS-1$
    /**Animation loop checkbox label key*/
    public final static String AnimationLoopLabel = "AnimationLoopLabel"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameAdoring = "Adoring"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameBegging = "Begging"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameDefault = "Default"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameDrinking = "Drinking"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameHello = "Hello"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameLaughting = "Laughting"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameLeaning = "Leaning"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameListen = "Listen"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameLonkingFarAway = "Lonking far away"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNamenone = "none"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNamePickPocketing = "Pick pocketing"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameReading = "Reading"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameSalutation = "Salutation"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameTalkingNormaly = "Talking normaly"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameTalkingWithAuthority = "Talking with authority"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameTaunt = "Taunt"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameVictory1 = "Victory1"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameVictory2 = "Victory2"; //$NON-NLS-1$
    /**Animation name key*/
    public final static String AnimationNameVictory3 = "Victory3"; //$NON-NLS-1$
    /**Application title key.*/
    public final static String ApplicationName = "ApplicationName"; //$NON-NLS-1$
    /**Comment tab title key*/
    public final static String CommentTabTitle = "CommentTabTitle"; //$NON-NLS-1$
    /**Suffix continue key*/
    public final static String ContinueSuffix = "ContinueSuffix"; //$NON-NLS-1$
    /**Default abort conversation script.*/
    public final static String DefaultAbortConv = "nw_walk_wp"; //$NON-NLS-1$
    /**Default end conversation script.*/
    public final static String DefaultEndConv = "nw_walk_wp"; //$NON-NLS-1$;
    /**.dlg file filter name key*/
    public final static String DLGFileFilterName = "DLGFileFilterName"; //$NON-NLS-1$
    /**Add node menuitem label key*/
    public final static String EditMenuAddNodeLabel = "EditMenuAddNodeLabel"; //$NON-NLS-1$
    /**Add node menuitem mnemonic key*/
    public final static String EditMenuAddNodeMnemonic = "EditMenuAddNodeMnemonic"; //$NON-NLS-1$
    /**Copy menuitem label key*/
    public final static String EditMenuCopyLabel = "EditMenuCopyLabel"; //$NON-NLS-1$
    /**Copy menuitem mnemonic key*/
    public final static String EditMenuCopyMnemonic = "EditMenuCopyMnemonic"; //$NON-NLS-1$
    /**Cut menuitem label key*/
    public final static String EditMenuCutLabel = "EditMenuCutLabel"; //$NON-NLS-1$
    /**Cut menuitem mnemonic key*/
    public final static String EditMenuCutMnemonic = "EditMenuCutMnemonic"; //$NON-NLS-1$
    /**Delete node menuitem label key*/
    public final static String EditMenuDeleteNodeLabel = "EditMenuDeleteNodeLabel"; //$NON-NLS-1$
    /**Delete node menuitem mnemonic key*/
    public final static String EditMenuDeleteNodeMnemonic = "EditMenuDeleteNodeMnemonic"; //$NON-NLS-1$
    /**Edit menu label key*/
    public final static String EditMenuLabel = "EditMenuLabel"; //$NON-NLS-1$
    /**Edit menu mnemonic key*/
    public final static String EditMenuMnemonic = "EditMenuMnemonic"; //$NON-NLS-1$
    /**Paste as link menuitem label key*/
    public final static String EditMenuPasteAsLinkLabel = "EditMenuPasteAsLinkLabel"; //$NON-NLS-1$
    /**Paste as link menuitem mnemonic key*/
    public final static String EditMenuPasteAsLinkMnemonic = "EditMenuPasteAsLinkMnemonic"; //$NON-NLS-1$
    /**Paste menuitem label key*/
    public final static String EditMenuPasteLabel = "EditMenuPasteLabel"; //$NON-NLS-1$
    /**Paste menuitem mnemonic key*/
    public final static String EditMenuPasteMnemonic = "EditMenuPasteMnemonic"; //$NON-NLS-1$
    /**Redo menuitem label key*/
    public final static String EditMenuRedoLabel = "EditMenuRedoLabel"; //$NON-NLS-1$
    /**Redo menuitem mnemonic key*/
    public final static String EditMenuRedoMnemonic = "EditMenuRedoMnemonic"; //$NON-NLS-1$
    /**Undo menuitem label key*/
    public final static String EditMenuUndoLabel = "EditMenuUndoLabel"; //$NON-NLS-1$
    /**Undo menuitem mnemonic key*/
    public final static String EditMenuUndoMnemonic = "EditMenuUndoMnemonic"; //$NON-NLS-1$
    /**Suffix end key*/
    public final static String EndSuffix = "EndSuffix"; //$NON-NLS-1$
    /**ERF file dialog inport Selection button label*/
    public final static String ERFFileInportDialogERFButton = "ERFFileInportDialogERFButton";
    /**ERF file dialog inport selection button mnemonic*/
    public final static String ERFFileInportDialogERFButtonMnemonic =
        "ERFFileInportDialogERFButtonMnemonic";
    /**ERF file dialog inport content list label*/
    public final static String ERFFileInportDialogListLabel = "ERFFileInportDialogListLabel";
    /**ERF file dialog inport title*/
    public final static String ERFFileInportDialogTitle = "ERFFileInportDialogTitle";
    /**Error dialogs title key*/
    public final static String ErrorDialogsTitle = "ErrorDialogsTitle"; //$NON-NLS-1$
    /**Exit script resref label key*/
    public final static String ExitScriptLabel = "ExitScriptLabel"; //$NON-NLS-1$
    /**Field modification pattern key*/
    public final static String FieldModificationFormat = "FieldModificationFormat"; //$NON-NLS-1$
    /**Close all menuitem label key*/
    public final static String FileMenuCloseAllLabel = "FileMenuCloseAllLabel"; //$NON-NLS-1$
    /**Close all menuitem mnemonic key*/
    public final static String FileMenuCloseAllMnemonic = "FileMenuCloseAllMnemonic"; //$NON-NLS-1$
    /**Close menuitem label key*/
    public final static String FileMenuCloseLabel = "FileMenuCloseLabel"; //$NON-NLS-1$
    /**Close menuitem mnemonic key*/
    public final static String FileMenuCloseMnemonic = "FileMenuCloseMnemonic"; //$NON-NLS-1$
    /**File menu label key*/
    public final static String FileMenuLabel = "FileMenuLabel"; //$NON-NLS-1$
    /**File menu mnemonic key*/
    public final static String FileMenuMnemonic = "FileMenuMnemonic"; //$NON-NLS-1$
    /**New menuitem label key*/
    public final static String FileMenuNewLabel = "FileMenuNewLabel"; //$NON-NLS-1$
    /**New menuitem mnemonic key*/
    public final static String FileMenuNewMnemonic = "FileMenuNewMnemonic"; //$NON-NLS-1$
    /**Open from erf menuitem label key*/
    public final static String FileMenuOpenFromERFLabel = "FileMenuOpenFromERFLabel"; //$NON-NLS-1$
    /**Open from erf menuitem mnemonic key*/
    public final static String FileMenuOpenFromERFMnemonic = "FileMenuOpenFromERFMnemonic"; //$NON-NLS-1$
    /**Open menuitem label key*/
    public final static String FileMenuOpenLabel = "FileMenuOpenLabel"; //$NON-NLS-1$
    /**Open menuitem mnemonic key*/
    public final static String FileMenuOpenMnemonic = "FileMenuOpenMnemonic"; //$NON-NLS-1$
    /**Quit menuitem label key*/
    public final static String FileMenuQuitLabel = "FileMenuQuitLabel"; //$NON-NLS-1$
    /**Quit menuitem mnemonic key*/
    public final static String FileMenuQuitMnemonic = "FileMenuQuitMnemonic"; //$NON-NLS-1$
    /**Save all menuitem label key*/
    public final static String FileMenuSaveAllLabel = "FileMenuSaveAllLabel"; //$NON-NLS-1$
    /**Save all menuitem mnemonic key*/
    public final static String FileMenuSaveAllMnemonic = "FileMenuSaveAllMnemonic"; //$NON-NLS-1$
    /**Save as menuitem label key*/
    public final static String FileMenuSaveAsLabel = "FileMenuSaveAsLabel"; //$NON-NLS-1$
    /**Save as menuitem mnemonic key*/
    public final static String FileMenuSaveAsMnemonic = "FileMenuSaveAsMnemonic"; //$NON-NLS-1$
    /**Save as xml menuitem label key*/
    public final static String FileMenuSaveAsXMLLabel = "FileMenuSaveAsXMLLabel"; //$NON-NLS-1$
    /**Save as xml menuitem mnemonic key*/
    public final static String FileMenuSaveAsXMLMnemonic = "FileMenuSaveAsXMLMnemonic"; //$NON-NLS-1$
    /**Save menuitem label key*/
    public final static String FileMenuSaveLabel = "FileMenuSaveLabel"; //$NON-NLS-1$
    /**Save menuitem mnemonic key*/
    public final static String FileMenuSaveMnemonic = "FileMenuSaveMnemonic"; //$NON-NLS-1$
    /**.gdf file filter name key*/
    public final static String GDFFileFilterName = "GDFFileFilterName"; //$NON-NLS-1$
    /**Gender female*/
    public final static String GenderFemale = "GenderFemale"; //$NON-NLS-1$
    /**Gender combobox label key*/
    public final static String GenderLabel = "GenderLabel"; //$NON-NLS-1$
    /**Gender male*/
    public final static String GenderMale = "GenderMale"; //$NON-NLS-1$
    /**About menuitem label key*/
    public final static String HelpMenuAboutLabel = "HelpMenuAboutLabel"; //$NON-NLS-1$
    /**About menuitem mnemonic key*/
    public final static String HelpMenuAboutMnemonic = "HelpMenuAboutMnemonic"; //$NON-NLS-1$
    /**Help menu label key*/
    public final static String HelpMenuLabel = "HelpMenuLabel"; //$NON-NLS-1$
    /**Help menu mnemonic key*/
    public final static String HelpMenuMnemonic = "HelpMenuMnemonic"; //$NON-NLS-1$
    /**Journal entry name label key*/
    public final static String JournalEntryNameLabel = "JournalEntryNameLabel"; //$NON-NLS-1$
    /**Journal entry number label key*/
    public final static String JournalEntryNumberLabel = "JournalEntryNumberLabel"; //$NON-NLS-1$
    /**Language combobox label key*/
    public final static String LanguageLabel = "LanguageLabel"; //$NON-NLS-1$
    /**Language not available key*/
    public final static String LanguageNotAvailable = "LanguageNotAvailable"; //$NON-NLS-1$
    /**Base name for resource bundles */
    public final static String LanguagesBaseName = "NWNLanguages.Languages"; //$NON-NLS-1$
    /**New node text key*/
    public final static String NewNodeText = "NewNodeText"; //$NON-NLS-1$
    /**Delete node confirmation text.*/
    public final static String NodeDeleteConfirm = "NodeDeleteConfirm"; //$NON-NLS-1$;
    /**Delete node confirmation dialog title.*/
    public final static String NodeDeleteConfirmTitle = "NodeDeleteConfirmTitle"; //$NON-NLS-1$;
    /**Option menu label key*/
    public final static String OptionMenuLabel = "OptionMenuLabel"; //$NON-NLS-1$
    /**Option menu mnemonic key*/
    public final static String OptionMenuMnemonic = "OptionMenuMnemonic"; //$NON-NLS-1$
    /**Other tab title key*/
    public final static String OtherTabTitle = "OtherTabTitle"; //$NON-NLS-1$
    /**Pick button label key*/
    public final static String PickButtonLabel = "PickButtonLabel"; //$NON-NLS-1$
    /**Prevent camera zoom checkbox label key*/
    public final static String PreventCameraZoomLabel = "PreventCameraZoomLabel"; //$NON-NLS-1$
    /**Scripts tab title key*/
    public final static String ScriptTabTitle = "ScriptTabTitle"; //$NON-NLS-1$
    /**Sound resref label key*/
    public final static String SoundLabel = "SoundLabel"; //$NON-NLS-1$
    /**Speaker's tag label key*/
    public final static String SpeakersTagLabel = "SpeakersTagLabel"; //$NON-NLS-1$
    /**Speaker tab title key*/
    public final static String SpeakerTabTitle = "SpeakerTabTitle"; //$NON-NLS-1$
    /**Text appears when label key*/
    public final static String TextAppearsWhenLabel = "TextAppearsWhenLabel"; //$NON-NLS-1$
    /**Untitled file name*/
    public final static String UntitledDialog = "UntitledDialog"; //$NON-NLS-1$
}
