/*
 * Created on 12 juil. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNLanguages;

import java.awt.event.KeyEvent;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.ResourceBundle;

/**
 * 18 juil. 2003
 * @author Alexandre Brunel
 *
 * Handles the languages.
 */
public class Languages extends ResourceBundle
{

    private static boolean Initialized = false;
    private static String[] LanguagesList = null;
    private static Hashtable NWNLanguageMap = null;
    private static Hashtable NWNLanguageReverseMap = null;
    private static Hashtable Resources = null;

    /**
     * Creates the resources.
     */
    protected static synchronized void CreateMaps()
    {
        if (!Initialized)
        {
            NWNLanguageMap = new Hashtable();

            int k = 0;

            LanguagesList = new String[10];

            String temp;

            NWNLanguageMap.put(temp = "English", new Long(0)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "French", new Long(1)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "German", new Long(2)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Italian", new Long(3)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Spanish", new Long(4)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Polish", new Long(5)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Korean", new Long(128)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Chinese Traditional", new Long(129)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Chinese Simplified", new Long(130)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Japanese", new Long(131)); //$NON-NLS-1$
            LanguagesList[k++] = temp;

            Iterator i = NWNLanguageMap.keySet().iterator();

            NWNLanguageReverseMap = new Hashtable();

            while (i.hasNext())
            {
                Object key = i.next();

                NWNLanguageReverseMap.put(NWNLanguageMap.get(key), key);
            }

            Resources = new Hashtable();

            Resources.put(KeysHolder.ApplicationName, "Ghanima: External dialog editor for NeverWinter Nights beta 3"); //$NON-NLS-1$
            Resources.put(KeysHolder.ContinueSuffix, "[Continue]"); //$NON-NLS-1$
            Resources.put(KeysHolder.EndSuffix, "[EndDialog]"); //$NON-NLS-1$
            Resources.put(KeysHolder.LanguageNotAvailable, "<Language not available>"); //$NON-NLS-1$
            Resources.put(KeysHolder.FieldModificationFormat, "{0} modification."); //$NON-NLS-1$
            Resources.put(KeysHolder.NewNodeText, "<Enter the text here>"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameDefault, "Default"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNamenone, "none"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTaunt, "Taunt"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameSalutation, "Salutation"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameListen, "Listen"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameAdoring, "Adoring"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameHello, "Hello"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLeaning, "Leaning"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNamePickPocketing, "Pick pocketing"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTalkingNormaly, "Talking normaly"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameBegging, "Begging"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTalkingWithAuthority, "Talking with authority"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLaughting, "Laughting"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory1, "Victory1"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory2, "Victory2"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory3, "Victory3"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLonkingFarAway, "Lonking far away"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameDrinking, "Drinking"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameReading, "Reading"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderMale, "Male"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderFemale, "Female"); //$NON-NLS-1$
            Resources.put(KeysHolder.UntitledDialog, "Untitled"); //$NON-NLS-1$
            Resources.put(KeysHolder.SpeakerTabTitle, "Speaker"); //$NON-NLS-1$
            Resources.put(KeysHolder.SpeakersTagLabel, "Speaker's tag"); //$NON-NLS-1$
            Resources.put(KeysHolder.PickButtonLabel, "..."); //$NON-NLS-1$
            Resources.put(KeysHolder.ScriptTabTitle, "Scripts definition"); //$NON-NLS-1$
            Resources.put(KeysHolder.TextAppearsWhenLabel, "Text appears when"); //$NON-NLS-1$
            Resources.put(KeysHolder.ActivationscriptLabel, "Activation script"); //$NON-NLS-1$
            Resources.put(KeysHolder.OtherTabTitle, "Other actions"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationLabel, "Animation"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationLoopLabel, "Loop"); //$NON-NLS-1$
            Resources.put(KeysHolder.SoundLabel, "Sound"); //$NON-NLS-1$
            Resources.put(KeysHolder.JournalEntryNameLabel, "Journal entry name"); //$NON-NLS-1$
            Resources.put(KeysHolder.JournalEntryNumberLabel, "Journal entry number"); //$NON-NLS-1$
            Resources.put(KeysHolder.CommentTabTitle, "Comment"); //$NON-NLS-1$
            Resources.put(KeysHolder.LanguageLabel, "Language"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderLabel, "Gender"); //$NON-NLS-1$
            Resources.put(KeysHolder.ExitScriptLabel, "Exit script"); //$NON-NLS-1$
            Resources.put(KeysHolder.AbortScriptLabel, "Abort script"); //$NON-NLS-1$
            Resources.put(KeysHolder.PreventCameraZoomLabel, "Prevent camera zoom"); //$NON-NLS-1$
            Resources.put(KeysHolder.ErrorDialogsTitle, "Error"); //$NON-NLS-1$
            Resources.put(KeysHolder.DLGFileFilterName, "NWN Daialog files(*.dlg)"); //$NON-NLS-1$
            Resources.put(KeysHolder.GDFFileFilterName, "Ghanima dialog files(*.gdf)"); //$NON-NLS-1$
            Resources.put(KeysHolder.AllFormatsFileFilterName, "All supported formats(*.dlg,*.gdf)"); //$NON-NLS-1$
            Resources.put(KeysHolder.AboutEmailAddressFormat, "E-amil address: {0}"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuLabel, "File"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuMnemonic, new Integer(KeyEvent.VK_F));
            Resources.put(KeysHolder.FileMenuNewLabel, "New"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuNewMnemonic, new Integer(KeyEvent.VK_N));
            Resources.put(KeysHolder.FileMenuOpenLabel, "Open"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuOpenMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.FileMenuOpenFromERFLabel, "Open from ERF"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuOpenFromERFMnemonic, new Integer(KeyEvent.VK_F));
            Resources.put(KeysHolder.FileMenuCloseLabel, "Close"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseMnemonic, new Integer(KeyEvent.VK_C)); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseAllLabel, "Close all"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseAllMnemonic, new Integer(KeyEvent.VK_E));
            Resources.put(KeysHolder.FileMenuSaveLabel, "Save"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveMnemonic, new Integer(KeyEvent.VK_S));
            Resources.put(KeysHolder.FileMenuSaveAllLabel, "Save all"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAllMnemonic, new Integer(KeyEvent.VK_A));
            Resources.put(KeysHolder.FileMenuSaveAsLabel, "Save as"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAsMnemonic, new Integer(KeyEvent.VK_V));
            Resources.put(KeysHolder.FileMenuSaveAsXMLLabel, "Save as xml"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAsXMLMnemonic, new Integer(KeyEvent.VK_X));
            Resources.put(KeysHolder.FileMenuQuitLabel, "Quit"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuQuitMnemonic, new Integer(KeyEvent.VK_Q));
            Resources.put(KeysHolder.EditMenuLabel, "Edit"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuMnemonic, new Integer(KeyEvent.VK_E));
            Resources.put(KeysHolder.EditMenuUndoLabel, "Undo"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuUndoMnemonic, new Integer(KeyEvent.VK_U));
            Resources.put(KeysHolder.EditMenuRedoLabel, "Redo"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuRedoMnemonic, new Integer(KeyEvent.VK_R));
            Resources.put(KeysHolder.EditMenuAddNodeLabel, "Add node"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuAddNodeMnemonic, new Integer(KeyEvent.VK_A));
            Resources.put(KeysHolder.EditMenuCopyLabel, "Copy"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuCopyMnemonic, new Integer(KeyEvent.VK_C));
            Resources.put(KeysHolder.EditMenuPasteLabel, "Paste"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuPasteMnemonic, new Integer(KeyEvent.VK_P));
            Resources.put(KeysHolder.EditMenuPasteAsLinkLabel, "Paste as link"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuPasteAsLinkMnemonic, new Integer(KeyEvent.VK_P));
            Resources.put(KeysHolder.EditMenuCutLabel, "Cut"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuCutMnemonic, new Integer(KeyEvent.VK_U));
            Resources.put(KeysHolder.OptionMenuLabel, "Option"); //$NON-NLS-1$
            Resources.put(KeysHolder.OptionMenuMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.HelpMenuLabel, "Help"); //$NON-NLS-1$
            Resources.put(KeysHolder.HelpMenuMnemonic, new Integer(KeyEvent.VK_H));
            Resources.put(KeysHolder.HelpMenuAboutLabel, "About"); //$NON-NLS-1$
            Resources.put(KeysHolder.HelpMenuAboutMnemonic, new Integer(KeyEvent.VK_A));
            Resources.put(KeysHolder.EditMenuDeleteNodeLabel, "Delete node"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuDeleteNodeMnemonic, new Integer(KeyEvent.VK_D));

            Resources.put(KeysHolder.NodeDeleteConfirm, "This will also delete all link to that node. Continue?"); //$NON-NLS-1$
            Resources.put(KeysHolder.NodeDeleteConfirmTitle, "Deletting node."); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogTitle, "ERF inport"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogListLabel, "File content:"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogERFButton, "Brows"); //$NON-NLS-1$
            Resources.put(
                KeysHolder.ERFFileInportDialogERFButtonMnemonic,
                new Integer(KeyEvent.VK_B));
            Resources.put(KeysHolder.OkButton, "Ok"); //$NON-NLS-1$
            Resources.put(KeysHolder.OkButtonMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.CancelButton, "Cancel"); //$NON-NLS-1$
            Resources.put(KeysHolder.CancelButtonMnemonic, new Integer(KeyEvent.VK_C));

            Resources.put(KeysHolder.ERFFileInportDialogERFFileNameLabel, "ERF file:"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogFileListLabel, "Dialog files"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogFileSelectionTitle, "Select a file to inport"); //$NON-NLS-1$

            Resources.put(KeysHolder.NextButtonMnemonic, new Integer(KeyEvent.VK_N)); 
            Resources.put(KeysHolder.NextButton, "Next"); //$NON-NLS-1$
            Resources.put(KeysHolder.PreviousButtonMnemonic, new Integer(KeyEvent.VK_P));
            Resources.put(KeysHolder.PreviousButton, "Previous"); //$NON-NLS-1$

			Resources.put(KeysHolder.EndButtonMnemonic, new Integer(KeyEvent.VK_F));
									Resources.put(KeysHolder.EndButton, "Finished"); //$NON-NLS-1$

            Initialized = true;
        }
    }

    public Languages()
    {

        CreateMaps();

    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#getKeys()
     */
    public Enumeration getKeys()
    {
        return Resources.keys();
    }

    /**
     * Retrieves a laguage id thanks to it's name.
     * 
     * @param key name of the language to retrieve.
     * @return The id of the language whose name is key.
     */
    public long getLanguageId(String key)
    {
        return ((Long) NWNLanguageMap.get(key)).longValue();
    }

    /**
     * Retrieves a laguage name thanks to it's id number.
     * 
     * @param key id of the language to retrieve.
     * @return The name of the language whose id is key.
     */
    public String getLanguageName(long key)
    {
        return (String) NWNLanguageReverseMap.get(new Long(key));
    }
    /**
     * Returns the languages names list
     * @return A list of string.
     */
    public String[] getLanguagesList()
    {

        return LanguagesList;
    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#handleGetObject(java.lang.String)
     */
    protected Object handleGetObject(String key)
    {

        return Resources.get(key);
    }

    /* (non-Javadoc)
     * @see java.util.ListResourceBundle#getContents()
     */

}
