/*
 * Created on 12 juil. 2003
 *
 *   Copyright 2003 Alexandre Brunel
 * 
 *   This file is part of Ghanima beta version 1.
 * 
 *   Ghanima is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package NWNLanguages;

import java.awt.event.KeyEvent;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;

/**
 * 18 juil. 2003
 * @author Alexandre Brunel
 *
 * Handles the languages.
 */
public class Languages_fr extends Languages
{

    private static boolean Initialized = false;
    private static String[] LanguagesList = null;
    private static Hashtable NWNLanguageMap = null;
    private static Hashtable NWNLanguageReverseMap = null;
    private static Hashtable Resources = null;

    /**
     * Creates the resources.
     */
    protected static synchronized void CreateMaps()
    {
        if (!Initialized)
        {
            NWNLanguageMap = new Hashtable();

            int k = 0;

            LanguagesList = new String[10];

            String temp;

            NWNLanguageMap.put(temp = "Anglais", new Long(0)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Franais", new Long(1)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Allemand", new Long(2)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Italien", new Long(3)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Espagnole", new Long(4)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Polonais", new Long(5)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Koreen", new Long(128)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Chinois Traditionel", new Long(129)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Chinois Simplifi", new Long(130)); //$NON-NLS-1$
            LanguagesList[k++] = temp;
            NWNLanguageMap.put(temp = "Japonais", new Long(131)); //$NON-NLS-1$
            LanguagesList[k++] = temp;

            Iterator i = NWNLanguageMap.keySet().iterator();

            NWNLanguageReverseMap = new Hashtable();

            while (i.hasNext())
            {
                Object key = i.next();

                NWNLanguageReverseMap.put(NWNLanguageMap.get(key), key);
            }

            Resources = new Hashtable();

            Resources.put(KeysHolder.ApplicationName, "Ghanima: Editeur de dialogue pour NeverWinter Nights beta 3"); //$NON-NLS-1$
            Resources.put(KeysHolder.ContinueSuffix, "[Continuer]"); //$NON-NLS-1$
            Resources.put(KeysHolder.EndSuffix, "[Fin de Dialogue]"); //$NON-NLS-1$
            Resources.put(KeysHolder.LanguageNotAvailable, "<Langage non disponible>"); //$NON-NLS-1$
            Resources.put(KeysHolder.FieldModificationFormat, "Modification de {0}"); //$NON-NLS-1$
            Resources.put(KeysHolder.NewNodeText, "<Tapez le texte ici>"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameDefault, "Par dfaut"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNamenone, "Pas d'animation"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTaunt, "Raillerie"); //$NON-NLS-1$ 
            Resources.put(KeysHolder.AnimationNameSalutation, "Salutations"); //$NON-NLS-1$ TODO continuer
            Resources.put(KeysHolder.AnimationNameListen, "Perception auditive"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameAdoring, "Adoration"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameHello, "Saluer"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLeaning, "S'incliner"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNamePickPocketing, "Vol"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTalkingNormaly, "Parler normalement"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameBegging, "Parler de faon implorante"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameTalkingWithAuthority, "Parler avec autorit"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLaughting, "Parler en riant"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory1, "Victoire1"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory2, "Victoire2"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameVictory3, "Victoire3"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameLonkingFarAway, "Regarder au loin"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameDrinking, "Boire"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationNameReading, "Lire"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderMale, "Masculin"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderFemale, "Femminin"); //$NON-NLS-1$
            Resources.put(KeysHolder.UntitledDialog, "Sans titre"); //$NON-NLS-1$
            Resources.put(KeysHolder.SpeakerTabTitle, "Propritaire"); //$NON-NLS-1$
            Resources.put(KeysHolder.SpeakersTagLabel, "Tag du propritaire"); //$NON-NLS-1$
            Resources.put(KeysHolder.PickButtonLabel, "..."); //$NON-NLS-1$
            Resources.put(KeysHolder.ScriptTabTitle, "Scripts associs"); //$NON-NLS-1$
            Resources.put(KeysHolder.TextAppearsWhenLabel, "Condition d'excution"); //$NON-NLS-1$
            Resources.put(KeysHolder.ActivationscriptLabel, "Action consquente"); //$NON-NLS-1$
            Resources.put(KeysHolder.OtherTabTitle, "Autres actions"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationLabel, "Animation"); //$NON-NLS-1$
            Resources.put(KeysHolder.AnimationLoopLabel, "Boucle"); //$NON-NLS-1$
            Resources.put(KeysHolder.SoundLabel, "Son"); //$NON-NLS-1$
            Resources.put(KeysHolder.JournalEntryNameLabel, "Journal"); //$NON-NLS-1$
            Resources.put(KeysHolder.JournalEntryNumberLabel, "Numro de l'entre"); //$NON-NLS-1$
            Resources.put(KeysHolder.CommentTabTitle, "Commentaires"); //$NON-NLS-1$
            Resources.put(KeysHolder.LanguageLabel, "Langue"); //$NON-NLS-1$
            Resources.put(KeysHolder.GenderLabel, "Genre"); //$NON-NLS-1$
            Resources.put(KeysHolder.ExitScriptLabel, "Script de fin"); //$NON-NLS-1$
            Resources.put(KeysHolder.AbortScriptLabel, "Script d'abandon"); //$NON-NLS-1$
            Resources.put(KeysHolder.PreventCameraZoomLabel, "Empcher le zoom de la camera"); //$NON-NLS-1$
            Resources.put(KeysHolder.ErrorDialogsTitle, "Erreur"); //$NON-NLS-1$
            Resources.put(KeysHolder.DLGFileFilterName, "Fichiers de dialogue pour NWN(*.dlg)"); //$NON-NLS-1$
            Resources.put(KeysHolder.GDFFileFilterName, "Fichiers de dialogue pour Ghanima(*.gdf)"); //$NON-NLS-1$
            Resources.put(KeysHolder.AllFormatsFileFilterName, "Tous les fichiers supports(*.dlg,*.gdf)"); //$NON-NLS-1$
            Resources.put(KeysHolder.AboutEmailAddressFormat, "Adresse lectronique: {0}"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuLabel, "Fichier"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuMnemonic, new Integer(KeyEvent.VK_F));
            Resources.put(KeysHolder.FileMenuNewLabel, "Nouveau"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuNewMnemonic, new Integer(KeyEvent.VK_N));
            Resources.put(KeysHolder.FileMenuOpenLabel, "Ouvrir"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuOpenMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.FileMenuOpenFromERFLabel, "Ouvrir depuis un fichier ERF"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuOpenFromERFMnemonic, new Integer(KeyEvent.VK_R));
            Resources.put(KeysHolder.FileMenuCloseLabel, "Fermer"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseMnemonic, new Integer(KeyEvent.VK_F)); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseAllLabel, "Tout fermer"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuCloseAllMnemonic, new Integer(KeyEvent.VK_T));
            Resources.put(KeysHolder.FileMenuSaveLabel, "Enregistrer"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveMnemonic, new Integer(KeyEvent.VK_E));
            Resources.put(KeysHolder.FileMenuSaveAllLabel, "Tour enregistrer"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAllMnemonic, new Integer(KeyEvent.VK_U));
            Resources.put(KeysHolder.FileMenuSaveAsLabel, "Enregistrer sous"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAsMnemonic, new Integer(KeyEvent.VK_S));
            Resources.put(KeysHolder.FileMenuSaveAsXMLLabel, "Enregistrer au format xml"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuSaveAsXMLMnemonic, new Integer(KeyEvent.VK_X));
            Resources.put(KeysHolder.FileMenuQuitLabel, "Quitter"); //$NON-NLS-1$
            Resources.put(KeysHolder.FileMenuQuitMnemonic, new Integer(KeyEvent.VK_Q));
            Resources.put(KeysHolder.EditMenuLabel, "Edition"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuMnemonic, new Integer(KeyEvent.VK_E));
            Resources.put(KeysHolder.EditMenuUndoLabel, "Annuler"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuUndoMnemonic, new Integer(KeyEvent.VK_A));
            Resources.put(KeysHolder.EditMenuRedoLabel, "Restaurer"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuRedoMnemonic, new Integer(KeyEvent.VK_R));
            Resources.put(KeysHolder.EditMenuAddNodeLabel, "Ajouter un noeud"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuAddNodeMnemonic, new Integer(KeyEvent.VK_N));
            Resources.put(KeysHolder.EditMenuCopyLabel, "Copier"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuCopyMnemonic, new Integer(KeyEvent.VK_C));
            Resources.put(KeysHolder.EditMenuPasteLabel, "Coller"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuPasteMnemonic, new Integer(KeyEvent.VK_L));
            Resources.put(KeysHolder.EditMenuPasteAsLinkLabel, "Copier en tant que lien"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuPasteAsLinkMnemonic, new Integer(KeyEvent.VK_T));
            Resources.put(KeysHolder.EditMenuCutLabel, "Couper"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuCutMnemonic, new Integer(KeyEvent.VK_P));
            Resources.put(KeysHolder.OptionMenuLabel, "Option"); //$NON-NLS-1$
            Resources.put(KeysHolder.OptionMenuMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.HelpMenuLabel, "Aide"); //$NON-NLS-1$
            Resources.put(KeysHolder.HelpMenuMnemonic, new Integer(KeyEvent.VK_A));
            Resources.put(KeysHolder.HelpMenuAboutLabel, "A propos"); //$NON-NLS-1$
            Resources.put(KeysHolder.HelpMenuAboutMnemonic, new Integer(KeyEvent.VK_P));
            Resources.put(KeysHolder.EditMenuDeleteNodeLabel, "Supprimer un noeud"); //$NON-NLS-1$
            Resources.put(KeysHolder.EditMenuDeleteNodeMnemonic, new Integer(KeyEvent.VK_S));
            Resources.put(KeysHolder.NodeDeleteConfirm, "Les liens vers ce noeud seront aussi effacer, continuer?"); //$NON-NLS-1$
            Resources.put(KeysHolder.NodeDeleteConfirmTitle, "Effacement du noeud."); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogTitle, "ERF importation"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogListLabel, "Contenu du fichier:"); //$NON-NLS-1$
            Resources.put(KeysHolder.ERFFileInportDialogERFButton, "Parcourir"); //$NON-NLS-1$
			Resources.put(KeysHolder.ERFFileInportDialogERFButtonMnemonic, new Integer(KeyEvent.VK_P)); 
            Resources.put(KeysHolder.OkButton, "Ok"); //$NON-NLS-1$
            Resources.put(KeysHolder.OkButtonMnemonic, new Integer(KeyEvent.VK_O));
            Resources.put(KeysHolder.CancelButton, "Annuler"); //$NON-NLS-1$
            Resources.put(KeysHolder.CancelButtonMnemonic, new Integer(KeyEvent.VK_A));
			Resources.put(KeysHolder.ERFFileInportDialogERFFileNameLabel, "Fichier ERF:"); //$NON-NLS-1$
			Resources.put(KeysHolder.ERFFileInportDialogFileListLabel, "Fichiers de dialogue"); //$NON-NLS-1$
			Resources.put(KeysHolder.ERFFileInportDialogFileSelectionTitle, "Slectionnez un fichier  importer"); //$NON-NLS-1$
			
			Resources.put(KeysHolder.NextButtonMnemonic, new Integer(KeyEvent.VK_S)); 
			Resources.put(KeysHolder.NextButton, "Suivant"); //$NON-NLS-1$
			Resources.put(KeysHolder.PreviousButtonMnemonic, new Integer(KeyEvent.VK_P));
			Resources.put(KeysHolder.PreviousButton, "Prcdant"); //$NON-NLS-1$
			
			Resources.put(KeysHolder.EndButtonMnemonic, new Integer(KeyEvent.VK_T));
						Resources.put(KeysHolder.EndButton, "Termin"); //$NON-NLS-1$
			
			Initialized = true;
        }
    }

    public Languages_fr()
    {

        CreateMaps();

    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#getKeys()
     */
    public Enumeration getKeys()
    {
        return Resources.keys();
    }

    /**
     * Retrieves a laguage id thanks to it's name.
     * 
     * @param key name of the language to retrieve.
     * @return The id of the language whose name is key.
     */
    public long getLanguageId(String key)
    {
        return ((Long) NWNLanguageMap.get(key)).longValue();
    }

    /**
     * Retrieves a laguage name thanks to it's id number.
     * 
     * @param key id of the language to retrieve.
     * @return The name of the language whose id is key.
     */
    public String getLanguageName(long key)
    {
        return (String) NWNLanguageReverseMap.get(new Long(key));
    }
    /**
     * Returns the languages names list
     * @return A list of string.
     */
    public String[] getLanguagesList()
    {

        return LanguagesList;
    }

    /* (non-Javadoc)
     * @see java.util.ResourceBundle#handleGetObject(java.lang.String)
     */
    protected Object handleGetObject(String key)
    {

        return Resources.get(key);
    }

    /* (non-Javadoc)
     * @see java.util.ListResourceBundle#getContents()
     */

}
